From 0fff86ce6f157dd87aeccdb2473c5928fa326d0f Mon Sep 17 00:00:00 2001
From: manisha <manisha_kanyal.scsebtech@galgotiasuniversity.edu.in>
Date: Aug 10 2021 11:22:42 +0000
Subject: [PATCH 5/11] implemented react-i18next


---

diff --git a/.gitignore b/.gitignore
index 5504588..e580f24 100644
--- a/.gitignore
+++ b/.gitignore
@@ -1,4 +1,4 @@
-# See https://help.github.com/articles/ignoring-files/ for more about ignoring files.
+#  https://help.github.com/articles/ignoring-files/ for more about ignoring files.
 
 # dependencies
 /node_modules
diff --git a/src/App.js b/src/App.js
index fb0eb5b..7cefd22 100644
--- a/src/App.js
+++ b/src/App.js
@@ -1,21 +1,11 @@
-import React, { useEffect } from "react"
-
+import React from "react"
 import { Route, Switch } from "react-router"
 import { BrowserRouter } from "react-router-dom"
-
 import Wizard from "./wizard/Wizard"
 import LandingPage from "./landingpage/LandingPage"
 import NotFound from "./NotFound"
-import { useDispatch } from "react-redux"
-import { changeLanguage } from "./actions/reduxActions"
+import "./i18n"
 const App = () => {
-  const dispatch = useDispatch()
-
-  useEffect(() => {
-    const lang = localStorage.getItem("locale") || "en"
-    dispatch(changeLanguage(lang))
-  }, [dispatch])
-
   return (
     <BrowserRouter basename={window.env.SUBDIR}>
       <Switch>
diff --git a/src/NotFound.js b/src/NotFound.js
index 86ffa11..d3233ba 100644
--- a/src/NotFound.js
+++ b/src/NotFound.js
@@ -2,10 +2,10 @@ import React from "react"
 import Layout from "./layout/Layout"
 import { Link } from "react-router-dom"
 import { Container } from "reactstrap"
-import { useSelector } from "react-redux"
+import { useTranslation } from "react-i18next"
 
 const Wizard = () => {
-  const { i18n } = useSelector((state) => state.locale)
+  const { t } = useTranslation()
 
   return (
     <Layout>
@@ -17,7 +17,7 @@ const Wizard = () => {
               😢
             </span>
           </h3>
-          <Link to="/"> {i18n.t("phrases.go_to_home")}</Link>
+          <Link to="/"> {t("go_to_home")}</Link>
         </p>
       </Container>
     </Layout>
diff --git a/src/actions/reduxActions.js b/src/actions/reduxActions.js
index b32bffc..1c96a21 100644
--- a/src/actions/reduxActions.js
+++ b/src/actions/reduxActions.js
@@ -85,8 +85,3 @@ export const toggleLandingPageModal = (status) => ({
   type: ActionTypes.TOGGLE_LANDING_PAGE_MODAL,
   payload: status,
 })
-
-export const changeLanguage = (lang) => ({
-  type: ActionTypes.CHANGE_LANGUAGE,
-  payload: lang,
-})
diff --git a/src/constants/index.js b/src/constants/index.js
index f78a042..7b60f04 100644
--- a/src/constants/index.js
+++ b/src/constants/index.js
@@ -6,5 +6,4 @@ export default {
   UPDATE_LANDING_PAGE_API_CALL_STATUS: "UPDATE_LANDING_PAGE_API_CALL_STATUS",
   UPDATE_WIZARD_API_CALL_STATUS: "UPDATE_WIZARD_API_CALL_STATUS",
   TOGGLE_LANDING_PAGE_MODAL: "TOGGLE_LANDING_PAGE_MODAL",
-  CHANGE_LANGUAGE: "CHANGE_LANGUAGE",
 }
diff --git a/src/i18n.js b/src/i18n.js
new file mode 100644
index 0000000..97a746e
--- /dev/null
+++ b/src/i18n.js
@@ -0,0 +1,34 @@
+import i18n from "i18next"
+import detector from "i18next-browser-languagedetector"
+import { initReactI18next } from "react-i18next"
+import Backend from "i18next-http-backend"
+import en from "./translation/en.json"
+
+const resources = {
+  en: {
+    translation: en,
+  },
+}
+
+i18n
+  .use(Backend)
+  .use(detector)
+  .use(initReactI18next)
+  .init({
+    react: {
+      useSuspense: false,
+    },
+    fallbackLng: "en",
+    debug: true,
+    keySeparator: false,
+
+    interpolation: {
+      defaultVariables: {
+        screenName: "foo",
+      },
+      escapeValue: false,
+    },
+    resources,
+  })
+
+export default i18n
diff --git a/src/landingpage/Blockers.js b/src/landingpage/Blockers.js
index f716df8..feac4fe 100644
--- a/src/landingpage/Blockers.js
+++ b/src/landingpage/Blockers.js
@@ -2,21 +2,20 @@ import React from "react"
 import { Row, Card, CardBody } from "reactstrap"
 import SourceLink from "./SourceLink"
 import BugStats from "./common/BugStats"
-import { useSelector } from "react-redux"
+import { useTranslation } from "react-i18next"
 
 const Blockers = (props) => {
-  const { i18n } = useSelector((state) => state.locale)
-
+  const { t } = useTranslation()
   return (
     <Card className="cards">
       <CardBody>
         <h1 className="text-center padded">
-          Fedora {props.release} {i18n.t("phrases.blockers_and_FEs")}{" "}
+          Fedora {props.release} {t("blockers_and_FEs")}{" "}
           <SourceLink href="https://qa.fedoraproject.org/blockerbugs/" />
         </h1>
         <Row>
-          <BugStats milestone={i18n.t("words.beta")} stats={props.data.beta} />
-          <BugStats milestone={i18n.t("words.final")} stats={props.data.final} />
+          <BugStats milestone={"Beta"} stats={props.data.beta} />
+          <BugStats milestone={"Final"} stats={props.data.final} />
         </Row>
       </CardBody>
     </Card>
diff --git a/src/landingpage/Events.js b/src/landingpage/Events.js
index 05991da..f8a8ee0 100644
--- a/src/landingpage/Events.js
+++ b/src/landingpage/Events.js
@@ -2,11 +2,10 @@ import React from "react"
 import dateFormat from "dateformat"
 import SourceLink from "./SourceLink"
 import { Card, CardBody, Row, Col } from "reactstrap"
-import { useSelector } from "react-redux"
+import { useTranslation } from "react-i18next"
 
 const Events = (props) => {
-  const { i18n } = useSelector((state) => state.locale)
-
+  const { t } = useTranslation()
   const meetings = props.data.map((meeting) => {
     const old = new Date(meeting.start)
     var date = old.getDate()
@@ -31,7 +30,7 @@ const Events = (props) => {
     <Card className="cards">
       <CardBody>
         <h1 className="text-center padded">
-          {i18n.t("phrases.Meetings_and_testdays_in_the_next_7_days")}{" "}
+          {t("Meetings_and_testdays_in_the_next_7_days")}{" "}
           <SourceLink href="https://apps.fedoraproject.org/calendar/QA/" />
         </h1>
         <Col md={12} className="padded">
diff --git a/src/landingpage/LandingPage.js b/src/landingpage/LandingPage.js
index bcd136b..24ac825 100644
--- a/src/landingpage/LandingPage.js
+++ b/src/landingpage/LandingPage.js
@@ -19,9 +19,10 @@ import * as R from "ramda"
 import { shallowEqual, useDispatch, useSelector } from "react-redux"
 import { loadData, toggleLandingPageModal } from "../actions/reduxActions"
 import Cookies from "universal-cookie"
+import { useTranslation } from "react-i18next"
 
 const LandingPage = () => {
-  const { i18n } = useSelector((state) => state.locale)
+  const { t } = useTranslation()
   const cookies = new Cookies()
   let available_components = ["events", "blockers", "minutes"]
   let enabled_components = cookies.get("landingpage_enabled_components")
@@ -110,7 +111,7 @@ const LandingPage = () => {
               {components}
               <Col md={{ size: 12, offset: 2 }} className="text-right">
                 <Modal isOpen={showModal} toggle={toggleModal}>
-                  <ModalHeader>{i18n.t("phrases.visibility_configuration")}</ModalHeader>
+                  <ModalHeader>{t("visibility_configuration")}</ModalHeader>
                   <ModalBody>
                     {available_components.map((item) => (
                       <React.Fragment key={item}>
@@ -125,10 +126,10 @@ const LandingPage = () => {
                             />{" "}
                             <label className="custom-control-label clickable" htmlFor={item}>
                               {item === "events"
-                                ? i18n.t("phrases.Meetings_and_testdays_in_the_next_7_days")
+                                ? t("Meetings_and_testdays_in_the_next_7_days")
                                 : item === "minutes"
-                                ? i18n.t("phrases.Fedora_QA_Meeting_Minutes")
-                                : i18n.t("phrases.Fedora_35_blockers_and_FEs")}
+                                ? t("Fedora_QA_Meeting_Minutes")
+                                : t("Fedora_35_blockers_and_FEs")}
                             </label>
                           </div>
                         </Col>
@@ -137,7 +138,7 @@ const LandingPage = () => {
                   </ModalBody>
                   <ModalFooter>
                     <Button color="primary" onClick={toggleModal}>
-                      {i18n.t("words.close")}
+                      {t("close")}
                     </Button>
                   </ModalFooter>
                 </Modal>
@@ -149,7 +150,7 @@ const LandingPage = () => {
                   className="pad btn btn-primary btn-block btn-wrap-text btn-lg active"
                   to="/wizard"
                   role="button">
-                  {i18n.t("phrases.do_you_have_some_spare_time")} <i className="fas fa-search"></i>
+                  {t("do_you_have_some_spare_time")} <i className="fas fa-search"></i>
                 </Link>
               </Col>
             </Row>
diff --git a/src/landingpage/Minutes.js b/src/landingpage/Minutes.js
index 0f61424..ec0f4bf 100644
--- a/src/landingpage/Minutes.js
+++ b/src/landingpage/Minutes.js
@@ -1,8 +1,8 @@
 import React from "react"
-import { useSelector } from "react-redux"
+import { useTranslation } from "react-i18next"
 import { Card, CardBody } from "reactstrap"
 const Events = (props) => {
-  const { i18n } = useSelector((state) => state.locale)
+  const { t } = useTranslation()
 
   const old = props.data.date
 
@@ -15,20 +15,20 @@ const Events = (props) => {
   return (
     <Card className="cards">
       <CardBody className="minutes">
-        <h1 className="text-center padded">{i18n.t("phrases.Fedora_QA_Meeting_Minutes")}</h1>
+        <h1 className="text-center padded">{t("Fedora_QA_Meeting_Minutes")}</h1>
         <div className="events minutes">
           <a target="_blank" href={props.data.link} rel="noopener noreferrer">
-            {i18n.t("phrases.Latest_minutes_from")} {dating} {timing}
+            {t("Latest_minutes_from")} {dating} {timing}
           </a>
           <br />
-          {i18n.t("words.Visit")}{" "}
+          {t("Visit")}{" "}
           <a
             target="_blank"
             href="https://meetbot.fedoraproject.org/sresults/?group_id=fedora-qa&type=team"
             rel="noopener noreferrer">
-            {i18n.t("words.meetbot")}
+            {t("meetbot")}
           </a>{" "}
-          {i18n.t("phrases.to_see_older")}.
+          {t("to_see_older")}.
           <br />
         </div>
       </CardBody>
diff --git a/src/landingpage/Timeline.js b/src/landingpage/Timeline.js
index 4ad0ff1..97a2253 100644
--- a/src/landingpage/Timeline.js
+++ b/src/landingpage/Timeline.js
@@ -1,10 +1,10 @@
 import React, { useState } from "react"
-import { useSelector } from "react-redux"
+import { useTranslation } from "react-i18next"
 import { Card, CardBody, Tooltip } from "reactstrap"
 import SourceLink from "./SourceLink"
 
 const Timeline = (props) => {
-  const { i18n } = useSelector((state) => state.locale)
+  const { t } = useTranslation()
 
   const [tooltipOpen, setTooltipOpen] = useState(false)
 
@@ -12,10 +12,10 @@ const Timeline = (props) => {
 
   const get_title = (summary) => {
     summary = summary.toLowerCase()
-    if (summary.includes("freeze")) return i18n.t("phrases.freeze_Text")
-    if (summary === "rawhide") return i18n.t("phrases.Rawhide_Text")
-    if (summary.includes("branch")) return i18n.t("phrases.branch_Text")
-    if (summary.includes("release")) return i18n.t("phrases.release_Text")
+    if (summary.includes("freeze")) return t("freeze_Text")
+    if (summary === "rawhide") return t("Rawhide_Text")
+    if (summary.includes("branch")) return t("branch_Text")
+    if (summary.includes("release")) return t("release_Text")
   }
 
   const line = props.data.map((milestone) => {
@@ -46,7 +46,7 @@ const Timeline = (props) => {
       <Card>
         <CardBody>
           <h1 className="text-center padded" width="150">
-            {i18n.t("phrases.current_development_schedule")}{" "}
+            {t("current_development_schedule")}{" "}
             <span href="#" id="TooltipExample">
               <i className="fas fa-question-circle light"></i>
             </span>
@@ -55,7 +55,7 @@ const Timeline = (props) => {
               isOpen={tooltipOpen}
               target="TooltipExample"
               toggle={toggle}>
-              {i18n.t("phrases.timeline_Text")}
+              {t("timeline_Text")}
             </Tooltip>{" "}
             <SourceLink href="https://fedorapeople.org/groups/schedule/" />
           </h1>
diff --git a/src/landingpage/common/BugStats.js b/src/landingpage/common/BugStats.js
index 0d42fae..67d7210 100644
--- a/src/landingpage/common/BugStats.js
+++ b/src/landingpage/common/BugStats.js
@@ -1,11 +1,10 @@
 import React from "react"
-import { useSelector } from "react-redux"
+import { useTranslation } from "react-i18next"
 import { Table, Col } from "reactstrap"
 
 const BugStats = (props) => {
   const { milestone, stats } = props
-
-  const { i18n } = useSelector((state) => state.locale)
+  const { t } = useTranslation()
 
   return (
     <Col md={6} className="bugscount">
@@ -21,19 +20,19 @@ const BugStats = (props) => {
           {stats && (
             <>
               <tr>
-                <td>{i18n.t("phrases.Proposed_Blockers")}</td>
+                <td>{t("Proposed_Blockers")}</td>
                 <td>{stats.blockers_proposed}</td>
               </tr>
               <tr>
-                <td>{i18n.t("phrases.Accepted_Blockers")}</td>
+                <td>{t("Accepted_Blockers")}</td>
                 <td>{stats.blockers}</td>
               </tr>
               <tr>
-                <td>{i18n.t("phrases.Proposed_FEs")}</td>
+                <td>{t("Proposed_FEs")}</td>
                 <td>{stats.fe_proposed}</td>
               </tr>
               <tr>
-                <td>{i18n.t("phrases.Accepted_FEs")}</td>
+                <td>{t("Accepted_FEs")}</td>
                 <td>{stats.fe}</td>
               </tr>
             </>
diff --git a/src/layout/Footer.js b/src/layout/Footer.js
index f1447ac..69976ca 100644
--- a/src/layout/Footer.js
+++ b/src/layout/Footer.js
@@ -1,15 +1,14 @@
 import React from "react"
-import { useSelector } from "react-redux"
+import { useTranslation } from "react-i18next"
 
 const Footer = () => {
-  const { i18n } = useSelector((state) => state.locale)
+  const { t } = useTranslation()
 
   return (
     <div className="footer">
       <div className="container">
-        <a href="https://pagure.io/fedora-qa/landingpage">{i18n.t("words.source")}</a>{" "}
-        {i18n.t("phrases.on_Pagure")}{" "}
-        <span className="float-right">{i18n.t("words.version")} 0.1.0</span>
+        <a href="https://pagure.io/fedora-qa/landingpage">{t("source")}</a> {t(".on_Pagure")}{" "}
+        <span className="float-right">{t("version")} 0.1.0</span>
       </div>
     </div>
   )
diff --git a/src/layout/Masthead.js b/src/layout/Masthead.js
index 8295705..52bcf2f 100644
--- a/src/layout/Masthead.js
+++ b/src/layout/Masthead.js
@@ -13,13 +13,9 @@ import {
 import { API_CALL_STATUS_VALUES } from "../constants/ProjectConstants"
 import { ROUTE } from "../constants/Routes"
 import logo from "./logo.png"
-import {
-  changeLanguage,
-  loadData,
-  loadWizardData,
-  toggleLandingPageModal,
-} from "../actions/reduxActions"
+import { loadData, loadWizardData, toggleLandingPageModal } from "../actions/reduxActions"
 import { shallowEqual, useDispatch, useSelector } from "react-redux"
+import { useTranslation } from "react-i18next"
 
 const selectWizardFromStore = (state) => state.wizard.api_call_status
 const selectLandingPageFromStore = (state) => state.landing_page.api_call_status
@@ -32,7 +28,7 @@ const language = [
 ]
 
 const Masthead = () => {
-  const { i18n } = useSelector((state) => state.locale)
+  const { t, i18n } = useTranslation()
   const [dropdownOpen, setDropdownOpen] = useState(false)
   const [lang, setLang] = useState("")
 
@@ -74,8 +70,9 @@ const Masthead = () => {
   }
 
   const handleClick = (lang) => {
+    i18n.changeLanguage(lang)
+    localStorage.setItem("locale", lang)
     setLang(lang)
-    dispatch(changeLanguage(lang))
   }
 
   useEffect(() => {
@@ -103,7 +100,7 @@ const Masthead = () => {
                   <span className="fa-lg mr-1 text-danger">
                     <i className="fas fa-exclamation-triangle"></i>
                   </span>
-                  <span className="mr-3">{i18n.t("words.Retrying")}</span>
+                  <span className="mr-3">{t("Retrying")}</span>
                 </>
               )}
               <span className="fa-lg mr-3">
@@ -116,7 +113,7 @@ const Masthead = () => {
               <span className="fa-lg mr-1">
                 <i class="fas fa-exclamation-triangle"></i>
               </span>
-              <span className="mr-3">{i18n.t("phrases.Failed_to_fetch_data")}</span>
+              <span className="mr-3">{t("Failed_to_fetch_data")}</span>
               {handleRetry && (
                 <Button outline color="danger" size="sm" onClick={handleRetry}>
                   Retry
@@ -124,18 +121,15 @@ const Masthead = () => {
               )}
             </>
           )}
-          {ROUTE.LANDING_PAGE === location.pathname && (
-            <ButtonDropdown isOpen={dropdownOpen} toggle={toggle}>
-              <DropdownToggle caret>
-                {lang ? lang : i18n.t("phrases.select_language")}
-              </DropdownToggle>
-              <DropdownMenu>
-                {language.map((item) => (
-                  <DropdownItem onClick={() => handleClick(item.lang)}>{item.name}</DropdownItem>
-                ))}
-              </DropdownMenu>
-            </ButtonDropdown>
-          )}
+
+          <ButtonDropdown isOpen={dropdownOpen} toggle={toggle}>
+            <DropdownToggle caret>{lang ? lang : t("select_language")}</DropdownToggle>
+            <DropdownMenu>
+              {language.map((item) => (
+                <DropdownItem onClick={() => handleClick(item.lang)}>{item.name}</DropdownItem>
+              ))}
+            </DropdownMenu>
+          </ButtonDropdown>
 
           {ROUTE.LANDING_PAGE === location.pathname && (
             <Button color="primary" onClick={toggleModal}>
diff --git a/src/reducers/index.js b/src/reducers/index.js
index 731ecbb..7f00ae5 100644
--- a/src/reducers/index.js
+++ b/src/reducers/index.js
@@ -1,6 +1,4 @@
 import ActionTypes from "../constants"
-import i18n from "i18n-js"
-import en from "../translation/en"
 
 const defaultState = {
   landing_page: {
@@ -23,9 +21,6 @@ const defaultState = {
   landing_page_controls: {
     showModal: false,
   },
-  locale: {
-    i18n: i18n,
-  },
 }
 
 export default (state = defaultState, action) => {
@@ -72,21 +67,6 @@ export default (state = defaultState, action) => {
         },
       }
 
-    case ActionTypes.CHANGE_LANGUAGE:
-      let locale = action.payload
-      localStorage.setItem("locale", locale)
-      i18n.locale = locale
-      i18n.fallbacks = true
-      i18n.translations = { en }
-      let newI18n = { ...i18n }
-      return {
-        ...state,
-        locale: {
-          ...state.locale,
-          i18n: newI18n,
-        },
-      }
-
     default:
       return {
         ...state,
diff --git a/src/wizard/Easyfix.js b/src/wizard/Easyfix.js
index 390c40d..beefbe2 100644
--- a/src/wizard/Easyfix.js
+++ b/src/wizard/Easyfix.js
@@ -1,7 +1,7 @@
 import React from "react"
 import { CollapsableCard } from "./components"
 import { Col } from "reactstrap"
-import { useSelector } from "react-redux"
+import { useTranslation } from "react-i18next"
 
 export default (props) => {
   return (
@@ -16,7 +16,7 @@ export default (props) => {
 }
 
 const EasyfixSection = (props) => {
-  const { i18n } = useSelector((state) => state.locale)
+  const { t } = useTranslation()
   var title = props.title
   var subsections = Object.keys(props.data)
 
@@ -29,18 +29,14 @@ const EasyfixSection = (props) => {
       )
 
       return (
-        <CollapsableCard
-          key={k}
-          title={title}
-          expand_class={i18n.t("words.primary")}
-          expand_text={i18n.t("words.See")}>
+        <CollapsableCard key={k} title={title} expand_class={t("primary")} expand_text={t("See")}>
           <EasyfixLinksList data={props.data[k]} />
         </CollapsableCard>
       )
     })
     title = (
       <span>
-        <b>{title}</b> - {i18n.t("phrases.is_a_group")}
+        <b>{title}</b> - {t("is_a_group")}
       </span>
     )
 
@@ -48,8 +44,8 @@ const EasyfixSection = (props) => {
       <CollapsableCard
         key={title}
         title={title}
-        expand_class={i18n.t("words.warning")}
-        expand_text={i18n.t("words.Expand!")}>
+        expand_class={t("warning")}
+        expand_text={t("Expand!")}>
         {subsections}
       </CollapsableCard>
     )
@@ -76,8 +72,8 @@ const EasyfixSection = (props) => {
       <CollapsableCard
         key={title}
         title={title}
-        expand_class={i18n.t("words.primary")}
-        expand_text={i18n.t("words.See")}>
+        expand_class={t("primary")}
+        expand_text={t("See")}>
         {links}
       </CollapsableCard>
     )
diff --git a/src/wizard/FedoraEasyKarma.js b/src/wizard/FedoraEasyKarma.js
index ffb83d4..73c9f85 100644
--- a/src/wizard/FedoraEasyKarma.js
+++ b/src/wizard/FedoraEasyKarma.js
@@ -1,20 +1,20 @@
 import React from "react"
-import { useSelector } from "react-redux"
 import { CollapsableBadge, ModalBadge } from "./components"
-import { Trans } from "react-i18next"
+import { Trans, useTranslation } from "react-i18next"
 
 export default (props) => {
-  const { i18n } = useSelector((state) => state.locale)
+  const { t } = useTranslation()
 
   if (props.data === undefined) return null
   else
     return (
       <div>
-        <h1>{i18n.t("phrases.What_is_Karma")}</h1>
-        Before a new version of a package is pushed to the Fedora&apos;s Updates repository, it
-        needs to be tested and proved functional.{" "}
+        <h1>{t("What_is_Karma")}</h1>
+        {t("Before_a_new_version_of_a_package")}{" "}
         <CollapsableBadge expand_text="Tell me more about the process!">
-          <Trans i18nKey="What_is_Karma_Text">
+          <Trans
+            i18nKey="What_is_Karma_Text"
+            components={[<a href="https://bodhi.fedoraproject.org/"> </a>]}>
             The updates are kept in{" "}
             <a target="_blank" rel="noopener noreferrer" href="https://bodhi.fedoraproject.org/">
               Bodhi
@@ -26,23 +26,23 @@ export default (props) => {
             through the acceptance process together.
           </Trans>
         </CollapsableBadge>
-        <h1 style={{ marginTop: 1 + "em" }}>{i18n.t("phrases.sure_let_me_do_it")}</h1>
+        <h1 style={{ marginTop: 1 + "em" }}>{t("sure_let_me_do_it")}</h1>
         <ol className="steps">
           <li>
-            {i18n.t("phrases.Fedora_Accounts_System")}{" "}
-            <CollapsableBadge expand_text={i18n.t("phrases.Dont_have_one_yet")}>
+            {t("Fedora_Accounts_System")}{" "}
+            <CollapsableBadge expand_text={t("Dont_have_one_yet")}>
               <ul>
                 <li>
-                  {i18n.t("words.Visit")}{" "}
+                  {t("Visit")}{" "}
                   <a
                     target="_blank"
                     rel="noopener noreferrer"
                     href="https://admin.fedoraproject.org/accounts/user/new">
                     FAS Sign-up page
                   </a>{" "}
-                  {i18n.t("phrases.and_create_it")}
+                  {t("and_create_it")}
                 </li>
-                <li>{i18n.t("phrases.note_the_user")}</li>
+                <li>{t("note_the_user")}</li>
               </ul>
             </CollapsableBadge>
           </li>
@@ -57,8 +57,8 @@ export default (props) => {
             </Trans>
           </li>
           <li>
-            {i18n.t("phrases.choose_an_update")}{" "}
-            <CollapsableBadge expand_text={i18n.t("phrases.Not_sure_how")}>
+            {t("choose_an_update")}{" "}
+            <CollapsableBadge expand_text={t("Not_sure_how")}>
               <Trans i18nKey="Have_a_look">
                 Have a look at the available packages in <code>updates-testing</code> repo, by
                 running <code>dnf --enablerepo=updates-testing list --refresh --upgrades</code> and
@@ -67,7 +67,7 @@ export default (props) => {
             </CollapsableBadge>
           </li>
           <li>
-            <Trans i18nKey="Install_the_packages">
+            <Trans i18nKey="Install_the_packages" components={[<strong></strong>]}>
               Install the package{" "}
               <code>sudo dnf --enablerepo=updates-testing update PACKAGE_NAME</code>, and test
               whether it works, as you would expect.
@@ -76,9 +76,10 @@ export default (props) => {
               installed as dependencies (shown during the installation process). Try to test those
               too, if possible.{" "}
             </Trans>
-
-            <CollapsableBadge expand_text={i18n.t("phrases.Need_some_tips")}>
-              <Trans i18nKey="Sometimes_the_update">
+            <CollapsableBadge expand_text={t("Need_some_tips")}>
+              <Trans
+                i18nKey="Sometimes_the_update"
+                components={[<br />, <code>fedora-easy-karma --fas-username=FAS_USERNAME</code>]}>
                 Sometimes, the update associated with the package you just installed fixes some
                 specific bugs, or has testcases associated with it.
                 <br />
@@ -86,7 +87,7 @@ export default (props) => {
                 <code>Bugs</code>, <code>Test Cases</code>, and/or <code>Notes</code> sections in
                 the detailed output.{" "}
               </Trans>
-              <ModalBadge expand_text={i18n.t("phrases.Want_something_a_bit_nicer")}>
+              <ModalBadge expand_text={t("Want_something_a_bit_nicer")}>
                 <Trans i18nKey="We_already_mentioned_bodhi">
                   We already mentioned Bodhi, several times. Instead of using the{" "}
                   <code>fedora-easy-karma</code> interface for submitting Karma and/or learning
@@ -108,7 +109,7 @@ export default (props) => {
               Run <code>fedora-easy-karma --fas-username=FAS_USERNAME</code> and report what you
               found out.{" "}
             </Trans>
-            <CollapsableBadge expand_text={i18n.t("phrases.New_to_fedora")}>
+            <CollapsableBadge expand_text={t("New_to_fedora")}>
               <Trans i18nKey="It_identifies_installed">
                 It identifies the packages installed from the <code>updates-testing</code>{" "}
                 repository, and matches them to the updates in Bodhi.
@@ -116,10 +117,17 @@ export default (props) => {
                 You are then presented with the relevant updates one-by-one, to submit Karma and a
                 comment.{" "}
               </Trans>
-              <ModalBadge expand_text={i18n.t("phrases.Not_sure_what_Karma_means")}>
+              <ModalBadge expand_text={t(" Not_sure_what_Karma_means")}>
                 <ol>
                   <li>
-                    <Trans i18nKey="Enter_to_mark_positive">
+                    <Trans
+                      i18nKey="Enter_to_mark_positive"
+                      components={[
+                        <a href="https://fedoraproject.org/wiki/QA:Update_feedback_guidelines">
+                          {" "}
+                        </a>,
+                        <code>1</code>,
+                      ]}>
                       Enter <code>1</code> to mark positive karma (the update works just fine, as
                       far as you can tell), or <code>-1</code> to mark the package as broken.{" "}
                       <br />
@@ -135,7 +143,12 @@ export default (props) => {
                     </Trans>
                   </li>
                   <li>
-                    <Trans i18nKey="Add_a_comment_even_if">
+                    <Trans
+                      i18nKey="Add_a_comment_even_if"
+                      components={[
+                        <br />,
+                        <code>I tried openning and editing a document, and it worked.</code>,
+                      ]}>
                       Add a comment - even if it works, try to describe what you tested. It can be
                       as easy as{" "}
                       <code>I tried openning and editing a document, and it worked.</code> when you
